/*
**  SGSystemProtocol.h
**
**  Copyright (c) 2002, 2003
**
**  Author: Yen-Ju Chen <yjchenx@hotmail.com>
**
**  This program is free software; you can redistribute it and/or modify
**  it under the terms of the GNU Lesser General Public License as published by
**  the Free Software Foundation; either version 2 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _Musicbox_ShengGuang_H_SGSystemProtocol
#define _Musicbox_ShengGuang_H_SGSystemProtocol

#include <Foundation/NSObject.h>

@class NSString;
@class NSArray;

@protocol SGSystemProtocol <NSObject>

+ (id) singleInstance;

/* Audio file methods */
- (BOOL) isSoundPlaying;
- (BOOL) isSoundPaused;
- (BOOL) playSound: (NSString *) filename;
- (BOOL) stopSound;
- (BOOL) pauseSound;
- (BOOL) resumeSound;
- (BOOL) seekSound: (int) seconds;
- (int) lengthOfSound: (NSString *) filename; /* seconds */
- (int) currentTimeOfSound; /* For audio file, in seconds */
- (NSArray *) availableFormats;

/* Audio CD methods */
- (BOOL) hasCDROM;
- (BOOL) isCDPlaying;
- (BOOL) playCD: (int) track;
- (BOOL) playCD: (int) track at: (int) seconds;
- (BOOL) stopCD;
- (BOOL) pauseCD;
- (BOOL) resumeCD;
- (int) numberOfCDTracks;
- (BOOL) isCDPresent;
- (BOOL) ejectCD;
- (BOOL) openCD;
- (void) closeCD;
/* return array of dictionary with "length" and "offset" as keys 
 * for Cddb.bundle
 */
- (NSArray *) allCDTracks;
- (int) lengthOfCDTrack: (int) track; /* Don't handle open and close CD */
- (int) currentTimeOfCDTrack; /* For audio CD */

- (id) delegate;
- (void) setDelegate: (id) aDelegate;
@end

#endif /* _Musicbox_ShengGuang_H_SGSystemProtocol */
